<?php
/**
 * Aliases for special pages of PageSchemas extension.
 *
 * @file
 * @license GPL-2.0-or-later
 */

$specialPageAliases = [];

/** English (English) */
$specialPageAliases['en'] = [
	'GeneratePages' => [ 'GeneratePages' ],
	'EditSchema' => [ 'EditSchema' ],
];

/** Arabic (العربية) */
$specialPageAliases['ar'] = [
	'GeneratePages' => [ 'توليد_صفحات' ],
	'EditSchema' => [ 'تعديل_السكيما' ],
];

/** Egyptian Arabic (مصرى) */
$specialPageAliases['arz'] = [
	'GeneratePages' => [ 'توليد_صفحات' ],
	'EditSchema' => [ 'تعديل_السكيما' ],
];

/** German (Deutsch) */
$specialPageAliases['de'] = [
	'GeneratePages' => [ 'Seiten_generieren' ],
	'EditSchema' => [ 'Schema_bearbeiten' ],
];

/** Zazaki (Zazaki) */
$specialPageAliases['diq'] = [
	'GeneratePages' => [ 'PerréVırazin' ],
	'EditSchema' => [ 'ŞemaVırnayış' ],
];

/** Greek (Ελληνικά) */
$specialPageAliases['el'] = [
	'GeneratePages' => [ 'ΠαραγωγήΣελίδων' ],
	'EditSchema' => [ 'ΕπεξεργασίαΣχήματος' ],
];

/** Italian (italiano) */
$specialPageAliases['it'] = [
	'GeneratePages' => [ 'GeneraPagine' ],
	'EditSchema' => [ 'ModificaSchema' ],
];

/** Japanese (日本語) */
$specialPageAliases['ja'] = [
	'GeneratePages' => [ 'ページ生成' ],
	'EditSchema' => [ 'スキーマ編集' ],
];

/** Korean (한국어) */
$specialPageAliases['ko'] = [
	'GeneratePages' => [ '문서생성' ],
	'EditSchema' => [ '스키마편집' ],
];

/** Luxembourgish (Lëtzebuergesch) */
$specialPageAliases['lb'] = [
	'GeneratePages' => [ 'Säite_generéieren' ],
	'EditSchema' => [ 'Schema_änneren' ],
];

/** Macedonian (македонски) */
$specialPageAliases['mk'] = [
	'GeneratePages' => [ 'СоздајСтраници' ],
	'EditSchema' => [ 'УредиШема' ],
];

/** Dutch (Nederlands) */
$specialPageAliases['nl'] = [
	'GeneratePages' => [ 'PaginasAanmaken' ],
	'EditSchema' => [ 'SchemaBewerken' ],
];

/** Simplified Chinese (中文（简体）‎) */
$specialPageAliases['zh-hans'] = [
	'GeneratePages' => [ '生成页面' ],
	'EditSchema' => [ '编辑架构' ],
];

/** Traditional Chinese (中文（繁體）‎) */
$specialPageAliases['zh-hant'] = [
	'GeneratePages' => [ '產生頁面' ],
	'EditSchema' => [ '編輯綱要' ],
];
